CON

  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

  AUDIO         = 26                            'P26 is audio output for Prop BOE.  

OBJ

  fir   :       "rain_filter_1"

PUB  start

  cognew(@rain, fir.start(0)) 

DAT

              org       0
rain          mov       arg_addr,par            'Get busy address.
              add       arg_addr,#4             'Next long up is argument address.
              mov       dira,dira0              'Initialize dira for audio output.
              mov       ctra,ctra0              'Set up counter for DUTY mode.
              mov       period,cnt              'Establish first time sync.
              add       period,_22khz
        
main_lp       call      #random                 'Get next random number for white noise.
              mov       arg,rand                'Save in arg.
              
              'sar       arg,#2                 'Uncomment both lines to skip filtering.
              'jmp       #skip_filter
              
              wrlong    arg,arg_addr            'Write arg to hub.
              wrlong    one,par                 'Tell FIR filter we're ready with next sample.

:wait_lp      rdlong    arg,par wz              'Wiat for FIR filter to do its thing.
        if_nz jmp       #:wait_lp

              rdlong    arg,arg_addr            'Get filtered result.
              
skip_filter   add       arg,zero                'Add the AC zero level.
              waitcnt   period,_22khz           'Wait for next time sync.
              mov       frqa,arg                'Write output to counter.
              jmp       #main_lp                'Back for another.

'-------[Random: generate 32-bit random number in rand]------------------------

random        mov       ctr,#32
                               
:randlp       test      rand,#%10111 wc            
              rcr       rand,#1                    
              djnz      ctr,#:randlp

random_ret    ret

'-------[Constants & initialized variables]------------------------------------

dira0         long      1 << AUDIO
ctra0         long      %00110 << 26 | AUDIO 
rand          long      1
_22khz        long      80_000_000 / 22_000
one           long      1
zero          long      $8000_0000

'-------[Uninitialized variables]----------------------------------------------

arg_addr      res       1
arg           res       1
period        res       1
ctr           res       1      


    